//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// Z poniższym kodem nie jest związana żadna gwarancja poprawności działania.
// Program został dołączony do książki ".NET CLR. Księga eksperta" w celu
// ilustracji koncepcji i zasad przedstawionych w tej książce. Program może być 
// używany na własne ryzyko.
//
// Przyznaje się prawo do użycia lub kopiowania tego oprogramowania do dowolnego celu
// bez konieczności ponoszenia żadnych opłat pod warunkiem, że powyższe uwagi zostaną 
// zachowane we wszystkich kopiach. Przyznaje się także prawo do modyfikacji kodu
// i dystrybucji zmodyfikowanego kodu pod warunkiem zachowania powyższych uwag
// oraz dołączenia informacji mówiącej o modyfikacji kodu.
//
// 
// MarshalDlg.cpp : plik implementacji
//

#include "stdafx.h"
#include "Marshal.h"
#include "MarshalDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// Okno dialogowe CAboutDlg wykorzystywane przez App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dane okna dialogowego
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // Obsługa DDX/DDV

// Implementacja
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// Okno dialogowe CMarshalDlg



CMarshalDlg::CMarshalDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMarshalDlg::IDD, pParent)
	, operand1(0)
	, operand2(0)
	, result(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMarshalDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT1, operand1);
	DDX_Text(pDX, IDC_EDIT2, operand2);
	DDX_Text(pDX, IDC_EDIT3, result);
}

BEGIN_MESSAGE_MAP(CMarshalDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_ADD, OnClickedAdd)
	ON_BN_CLICKED(IDC_SUBTRACT, OnClickedSubtract)
	ON_BN_CLICKED(IDC_MULTIPLY, OnClickedMultiply)
	ON_BN_CLICKED(IDC_DIVIDE, OnClickedDivide)
END_MESSAGE_MAP()


// Procedury obsługi wiadomości CMarshalDlg

BOOL CMarshalDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Dodanie elementu menu "O programie..." do menu systemowego.

	// IDM_ABOUTBOX musi znajdować się w zasięgu poleceń systemowych.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Ustawienie ikonki dla tego okna dialogowego. Struktura wykonuje to automatycznie,
	//  jeśli główne okno aplikacji nie jest oknem dialogowym.
	SetIcon(m_hIcon, TRUE);			// Ustawienie dużej ikonki
	SetIcon(m_hIcon, FALSE);		// Ustawienie małej ikonki

	HRESULT hr = basicOperations.CoCreateInstance(__uuidof(Arithmetic::Arithmetic));
	if(FAILED(hr))
		return FALSE;
	
	return TRUE;  // zwrócenie TRUE, chyba że ognisko ustawiono na element sterujący
}

void CMarshalDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// Jeśli do okna dialogowego zostanie dodany przycisk minimalizacji, poniższy kod będzie niezbędny
//  do przeciągania ikonki. W przypadku aplikacji MFC korzystających z modelu dokument/widok
//  zostanie to wykonane automatycznie przez strukturę.

void CMarshalDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // kontekst urządzenia służący do rysowania

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Wypośrodkowanie ikonki w prostokącie klienta
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Rysowanie ikonki
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// System wywołuje tę funkcję w celu uzyskania wskaźnika, kiedy użytkownik przeciąga
//  zminimalizowane okno.
HCURSOR CMarshalDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CMarshalDlg::OnClickedAdd()
{
	UpdateData(TRUE);
	result = basicOperations->Add(operand1, operand2);
	UpdateData(FALSE);
}

void CMarshalDlg::OnClickedSubtract()
{
	UpdateData(TRUE);
	result = basicOperations->Subtract(operand1, operand2);
	UpdateData(FALSE);
}

void CMarshalDlg::OnClickedMultiply()
{
	UpdateData(TRUE);
	result = basicOperations->Multiply(operand1, operand2);
	UpdateData(FALSE);
}

void CMarshalDlg::OnClickedDivide()
{
	UpdateData(TRUE);
	result = basicOperations->Divide(operand1, operand2);
	UpdateData(FALSE);
}
